<?php

	require_once(dirname(dirname(dirname(dirname(__FILE__)))) . '/idealcheckout/includes/library.php');

	class idealcheckoutdirectebanking
	{
		var $code, $title, $description, $enabled, $form_action_url;

		// class constructor
		function idealcheckoutdirectebanking()
		{
			$this->icon = DIR_WS_ICONS . 'idealcheckoutdirectebanking.png';
			$this->code = 'idealcheckoutdirectebanking';
			$this->title = MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_TEXT_TITLE;
			$this->description = MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_TEXT_DESCRIPTION;
			$this->sort_order = MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_SORT_ORDER;
			// $this->enabled = MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS;

			// Minimum amount - start
			if(in_array(strtolower(MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS), array(1, '1', 'true', 'y', 'yes', 'ja')))
			{
				$cart_total = $_SESSION['cart']->total;

				if($cart_total >= 1.00)
				{
					$this->enabled = true;
				}
				else
				{
					$this->enabled = false;
				}
			}
			else
			{
				$this->enabled = false;
			}

			$this->email_footer = '';
		}

		// class methods
		function javascript_validation()
		{
			return true;
		}

		function selection()
		{
			return array('id' => $this->code, 'module' => $this->title);
		}

		function pre_confirmation_check()
		{
			return false;
		}

		function confirmation()
		{
			return array('title' => $this->description);
		}

		function process_button()
		{
			return '';
		}

		function payment_action()
		{
		}


		function before_process()
		{
			return false;
		}

		function after_process()
		{
			global $order, $tmp, $insert_id;

			if(true)
			{
				// Add transaction record to database
				$aDatabaseSettings = idealcheckout_getDatabaseSettings();

				$sStoreCode = idealcheckout_getStoreCode();
				$sGatewayCode = 'directebanking';
				$sLanguageCode = 'nl'; // nl, de, en
				$sCountryCode = '';
				$sCurrencyCode = 'EUR';

				$sOrderId = $insert_id;
				$sOrderCode = idealcheckout_getRandomCode(32);
				$aOrderParams = array();
				$sTransactionId = idealcheckout_getRandomCode(32);
				$sTransactionCode = idealcheckout_getRandomCode(32);
				$fTransactionAmount = round(str_replace(',', '', $order->info['pp_total'] * $order->info['currency_value']), 2);
				$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));
				$sTransactionPaymentUrl = xtc_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');
				$sTransactionSuccessUrl = xtc_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL');
				$sTransactionPendingUrl = xtc_href_link(FILENAME_CHECKOUT_SUCCESS, '', 'SSL');
				$sTransactionFailureUrl = xtc_href_link(FILENAME_CHECKOUT_PAYMENT, '', 'SSL');



				// Insert into #_transactions
				$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(idealcheckout_serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

				xtc_db_query($sql);


/*

				// Cleanup cart & sessions
				$_SESSION['cart']->reset(true);

				unset ($_SESSION['sendto']);
				unset ($_SESSION['billto']);
				unset ($_SESSION['shipping']);
				unset ($_SESSION['payment']);
				unset ($_SESSION['comments']);

*/

				$_SESSION['cart']->reset(true);

				// unregister session variables used during checkout
				unset ($_SESSION['sendto']);
				unset ($_SESSION['billto']);
				unset ($_SESSION['shipping']);
				unset ($_SESSION['payment']);
				unset ($_SESSION['comments']);


				// Redirect to checkout
				xtc_redirect(idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode);
			}
			return false;
		}

		function output_error()
		{
			debug_print_backtrace();
			exit;

			return false;
		}


		function check()
		{
			if(!isset($this->check))
			{
				$check_query = xtc_db_query("SELECT `configuration_value` FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` = 'MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS' LIMIT 1;");
				$this->check = xtc_db_num_rows($check_query);
			}

			return $this->check;
		}

		function install()
		{
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS', 'True', '6', '100', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS_TITLE', 'Status', '6', '100', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS_DESC', 'Direct E-Banking in/uitschakelen', '6', '100', now())");

			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_SORT_ORDER', '0', '6', '101', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_SORT_ORDER_TITLE', 'Sorteer volgorde', '6', '101', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_SORT_ORDER_DESC', '', '6', '101', now())");
			
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_LANGUAGE', 'nl', '6', '102', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_LANGUAGE_TITLE', 'Taal', '6', '102', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_LANGUAGE_DESC', '', '6', '102', now())");
		
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_ALLOWED', '', '6', '103', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_ALLOWED_TITLE', 'Zones', '6', '103', now())");
			xtc_db_query("INSERT INTO `" . TABLE_CONFIGURATION . "` (`configuration_key`, `configuration_value`, `configuration_group_id`, `sort_order`, `date_added`) values ('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_ALLOWED_DESC', '', '6', '103', now())");
			
		}

		function remove()
		{
			xtc_db_query("DELETE FROM `" . TABLE_CONFIGURATION . "` WHERE `configuration_key` IN ('" . implode("', '", $this->keys()) . "')");
		}

		function keys()
		{
			return array('MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_STATUS', 'MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_SORT_ORDER', 'MODULE_PAYMENT_IDEALCHECKOUTDIRECTEBANKING_LANGUAGE');
		}
	}

?>